package game.mvc.controllers 
{
    import flash.accessibility.Accessibility;
    import flash.display.Stage;
    import flash.events.KeyboardEvent;
    import flash.ui.Keyboard;
    
    public class KeysController
    {
        private var up:Boolean;
        private var down:Boolean;
        private var left:Boolean;
        private var right:Boolean;
        
        private var w:Boolean;
        private var a:Boolean;
        private var s:Boolean;
        private var d:Boolean;
        
        private var x:int;
        private var y:int;
        
        public function KeysController(stage:Stage) 
        {
            stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownListener);
            stage.addEventListener(KeyboardEvent.KEY_UP, keyUpListener);
        }
        
        private function keyUpListener(e:KeyboardEvent):void 
        {
            if (e.keyCode == Keyboard.LEFT) left = false;
            if (e.keyCode == Keyboard.RIGHT) right = false;
            if (e.keyCode == Keyboard.DOWN) down = false;
            if (e.keyCode == Keyboard.UP) up = false;
            if (e.keyCode == Keyboard.W) w = false;
            if (e.keyCode == Keyboard.A) a = false;
            if (e.keyCode == Keyboard.S) s = false;
            if (e.keyCode == Keyboard.D) d = false;
        }
        
        private function keyDownListener(e:KeyboardEvent):void 
        {
            if (e.keyCode == Keyboard.LEFT) left = true;
            if (e.keyCode == Keyboard.RIGHT) right = true;
            if (e.keyCode == Keyboard.DOWN) down = true;
            if (e.keyCode == Keyboard.UP) up = true;
            if (e.keyCode == Keyboard.W) w = true;
            if (e.keyCode == Keyboard.A) a = true;
            if (e.keyCode == Keyboard.S) s = true;
            if (e.keyCode == Keyboard.D) d = true;
        }
        
        public function update():void
        {
            x = 0;
            y = 0;
            if (left || a) x--;
            if (right || d) x++;
            if (up || w) y--;
            if (down || s) y++;
        }
        
        public function get isLeft():Boolean
        {
            return (x < 0 && y == 0) ? true : false;
        }
        
        public function get isRight():Boolean
        {
            return (x > 0 && y == 0) ? true : false;
        }
        
        public function get isDown():Boolean
        {
            return (x == 0 && y > 0) ? true : false;
        }
        
        public function get isUp():Boolean
        {
            return (x == 0 && y < 0) ? true : false;
        }
        
        public function get isUpLeft():Boolean
        {
            return (x < 0 && y < 0) ? true : false;
        }
        
        public function get isUpRight():Boolean
        {
            return (x > 0 && y < 0) ? true : false;
        }
        
        public function get isDownLeft():Boolean
        {
            return (x < 0 && y > 0) ? true : false;
        }
        
        public function get isDownRight():Boolean
        {
            return (x > 0 && y > 0) ? true : false;
        }
    }
}