package game.mvc.views.game.tank 
{
    import flash.display.Shape;
    import game.constants.Mathematics;
    import game.constants.Size;
    import game.mvc.model.tank.TankModel;
    
    public class TankView extends Shape
    {
        private static const COLOR:uint = 0x00BB00;
        private static const GUN_WIDTH:int = 10;
        private static const GUN_PADDING:int = 5;
        
        private var tankModel:TankModel;
        
        public function TankView(tankModel:TankModel) 
        {
            this.tankModel = tankModel;
            init();
        }
        
        private function init():void 
        {
            draw();
            update();
        }
        
        private function draw():void 
        {
            graphics.beginFill(COLOR);
            graphics.drawCircle(0, 0, Size.PLAYER_RADIUS);
            graphics.beginFill(COLOR);
            graphics.drawRect(0, -GUN_WIDTH >> 1, Size.PLAYER_RADIUS + GUN_PADDING, GUN_WIDTH);
            graphics.endFill();
        }
        
        public function update():void
        {
            x = tankModel.x;
            y = tankModel.y;
            rotation = tankModel.rotation * Mathematics.DEGREES_IN_RADIAN;
        }
    }
}